#version 420 compatibility

varying vec4 texcoord;
varying vec4 lmcoord;
varying vec4 color;

varying vec3 normal;

uniform sampler2D tex;
uniform sampler2D specular;

uniform int isEyeInWater;

uniform float frameTimeCounter;

void main() {
    vec4 albedo = texture2D(tex, texcoord.st) * color;
    vec4 speculart = texture2D(specular, texcoord.st);
    speculart.r = 1.0 - speculart.r;
    speculart.r *= speculart.r*speculart.r; 
/*DRAWBUFFERS:0124*/
    gl_FragData[0] = albedo;
    gl_FragData[1] = vec4(normal*0.5+0.5, 1.0);
    gl_FragData[2] = vec4(lmcoord.xy, 0.0, 1.0);
    gl_FragData[3] = vec4(speculart);
}